package com.foilen.quickchat.DAO;

import com.foilen.quickchat.Entities.Message;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

@Repository
@Transactional
public class MessagesDAOHibernate implements MessagesDAO {
    private static final Logger logger = Logger.getLogger(MessagesDAOHibernate.class.getName());
    
    @Autowired 
    private SessionFactory sessionFactory;

    @Override
    public void addLine(String nick, String message) {
        Message result = new Message();
		
        result.setNick(nick);
        result.setMessage(message);

        sessionFactory.getCurrentSession().save(result);
    }

    @Override
    public List<String> listMessages() {
        List<String> result = new ArrayList<String>();
        
        try {
            List<Message> messages = sessionFactory.getCurrentSession().createQuery("from Message order by id").list();
            
            for (Message m: messages) {
                result.add(m.getNick() + " > " + m.getMessage());
            }
        } catch (Exception e) {
            logger.log(Level.SEVERE, null, e);
        }
        
        return result;
    }
}
