package com.foilen.quickchat.web.controllers;

import com.foilen.quickchat.DAO.MessagesDAO;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

@Controller
@RequestMapping("/{view}/Messages")
public class MessagesController {
    private static final Logger logger = Logger.getLogger(MessagesController.class.getName());
    
    @Autowired
    private MessagesDAO messagesThreadDAO;
    
    @RequestMapping("addline/{nick}/{message}")
    public ModelAndView addline(@PathVariable String view, @PathVariable String nick, @PathVariable String message) {
        ModelAndView result = new ModelAndView(view + "-status");
        
        // Create the thread
        try {
            messagesThreadDAO.addLine(nick, message);
        } catch (Exception e) {
            logger.log(Level.SEVERE, null, e);
            
            result.addObject("status", "error");
            result.addObject("message", "Your message could not be added");
            
            return result;
        }
        
        result.addObject("status", "success");
        result.addObject("message", "Message added");
        
        return result;
    }
    
    @RequestMapping("list")
    public ModelAndView list(@PathVariable String view) {
        ModelAndView result = new ModelAndView(view + "-list");
        
        List<String> messages = messagesThreadDAO.listMessages();
        
        result.addObject("list", messages);
        
        return result;
    }
}
